using System;

namespace TestProject
{
	abstract class ArrayTestCase : TestCase 
	{
		public override bool Check(Object original, Object copy)
		{
			Array orig = (Array) original;
			Array cpy = (Array) copy;

			return orig.Length == cpy.Length && orig.Rank == cpy.Rank;
		}
	}

	class SimpleEnumArrayTest : ArrayTestCase 
	{
		public override Object GetData() 
		{
			return new TestEnum[]{TestEnum.first, TestEnum.second, TestEnum.third};
		}

		public override String Name 
		{
			get 
			{
				return "test for enum array";
			}
		}
	}

	class EmptyEnumArrayTest : ArrayTestCase 
	{
		public override Object GetData() 
		{
			return new TestEnum[10];
		}

		public override String Name 
		{
			get 
			{
				return "test for empty enum array";
			}
		}
	}

	class SimpleObjectArrayTest : ArrayTestCase 
	{
		public override Object GetData() 
		{
			return new Object[]{new Object(), new Object(), new Object()};
		}

		public override String Name 
		{
			get 
			{
				return "test for object array";
			}
		}
	}

	class EmptyObjectArrayTest : ArrayTestCase 
	{
		public override Object GetData() 
		{
			return new Object[10];
		}

		public override String Name 
		{
			get 
			{
				return "test for empty object array";
			}
		}
	}

	class SimpleStringArrayTest : ArrayTestCase 
	{
		public override Object GetData() 
		{
			return new String[]{"la", "le", "lu"};
		}

		public override String Name 
		{
			get 
			{
				return "test for string array";
			}
		}
	}

	class EmptyStringArrayTest : ArrayTestCase 
	{
		public override Object GetData() 
		{
			return new String[10];
		}

		public override String Name 
		{
			get 
			{
				return "test for empty string array";
			}
		}
	}
}
